import 'package:cuba_weather_municipality_dart/src/models/models.dart';
import 'package:cuba_weather_municipality_dart/src/repositories/repositories.dart';

/// Main class to provide package functionality.
class CubaWeatherMunicipality {
  final MunicipalityRepository _repository = MunicipalityRepository();

  /// Method that given a municipality of the user searches the cuban
  /// municipalities to find the best match and returns the municipality. The
  /// best match is considered as the cuban municipality of shorter length
  /// that contains the given municipality.
  MunicipalityModel get(String municipalityQuery, {bool suggestion = false}) {
    var municipality = _repository.getMunicipality(municipalityQuery);
    if (suggestion && municipality == null) {
      municipality = _repository.getSuggestion(municipalityQuery);
    }
    return municipality;
  }

  /// Method that returns the best match of the given municipality with the
  /// cuban municipalities. The best match is calculated using the
  /// Damerau-Levenshtein distance.
  MunicipalityModel suggestion(String municipality) {
    return _repository.getSuggestion(municipality);
  }
}
